// PlayListGeneratorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PlayListGenerator.h"
#include "PlayListGeneratorDlg.h"
#include "MyHyperLink.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CMyHyperLink	m_hyperlink;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
    m_hyperlink.SetLinkUrl("http://activex.moonvalley.com/");
    m_hyperlink.ActiveToolTip(1);
    m_hyperlink.SetTootTipText("Visit the Moon Valley ActiveX page.");
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LINK, m_hyperlink);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayListGeneratorDlg dialog

CPlayListGeneratorDlg::CPlayListGeneratorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPlayListGeneratorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPlayListGeneratorDlg)
	m_fileExtension = _T("");
	m_searchPath = _T("");
	m_currentSong = _T("");
	m_title = _T("");
	m_index = _T("");
	m_number = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPlayListGeneratorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlayListGeneratorDlg)
	DDX_Control(pDX, IDC_MVSBUTTON, m_MVSButton);
	DDX_Text(pDX, IDC_EXTENSION, m_fileExtension);
	DDX_Text(pDX, IDC_PATH, m_searchPath);
	DDX_Control(pDX, IDC_PLAYLISTCTRL1, m_playlist);
	DDX_Text(pDX, IDC_CURRENT_SONG, m_currentSong);
	DDX_Text(pDX, IDC_TITLE, m_title);
	DDX_Text(pDX, IDC_CURRENT_INDEX, m_index);
	DDX_Text(pDX, IDC_NUMBER_OF_SONGS, m_number);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPlayListGeneratorDlg, CDialog)
	//{{AFX_MSG_MAP(CPlayListGeneratorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEARCH, OnSearch)
	ON_BN_CLICKED(IDC_LAUNCH_WINDOW, OnLaunchWindow)
	ON_BN_CLICKED(IDC_CLOSE_WINDOW, OnCloseWindow)
	ON_BN_CLICKED(IDC_CLEAR_LIST, OnClearList)
	ON_BN_CLICKED(IDC_PREVIOUS, OnPrevious)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_RANDOM, OnRandom)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_BK_COLOR, OnBkColor)
	ON_BN_CLICKED(IDC_TEXT_COLOR, OnTextColor)
	ON_BN_CLICKED(IDC_TEXT_BK_COLOR, OnTextBkColor)
	ON_BN_CLICKED(IDC_MVSBUTTON, OnMvsbutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayListGeneratorDlg message handlers

BOOL CPlayListGeneratorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    m_MVSButton.LoadBitmap(IDB_MVSLOGO);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPlayListGeneratorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPlayListGeneratorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPlayListGeneratorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// This method is called when the user clicks the Search button
void CPlayListGeneratorDlg::OnSearch() 
{
	UpdateData();

	// search for songs using the parameters specified in the text boxes
	m_playlist.SearchForSongs((LPCTSTR)m_fileExtension, (LPCTSTR)m_searchPath);

	UpdateData();

	m_number.Format("%.2d", m_playlist.GetNumberOfSongs()); // update the number of songs

	UpdateData(FALSE);
	
}

BEGIN_EVENTSINK_MAP(CPlayListGeneratorDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CPlayListGeneratorDlg)
	ON_EVENT(CPlayListGeneratorDlg, IDC_PLAYLISTCTRL1, 1 /* OnSelectionChanged */, OnSelectionChangedPlaylistctrl1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

// This method is called when the OnSelectionChanged event occurs on the control
void CPlayListGeneratorDlg::OnSelectionChangedPlaylistctrl1() 
{
	m_currentSong = m_playlist.GetCurrentSong(); // update the current song file name
	m_title = m_playlist.GetCurrentSongTitle(); // update the current song title
	m_index.Format("%.2d", m_playlist.GetCurrentSongIndex()); // update the index number

	UpdateData(FALSE);
	
}

// This method is called when the user clicks the Launch Window button
void CPlayListGeneratorDlg::OnLaunchWindow() 
{
	// launch the external window with hardcoded values
	m_playlist.UseExternalWindow("PlayList Generator", 200);
	
}

// This method is called when the user clicks the Close Window button
void CPlayListGeneratorDlg::OnCloseWindow() 
{
	m_playlist.CloseExternalWindow(); // call the close external window method
	
}

// This method is called when the user clicks the Clear List button
void CPlayListGeneratorDlg::OnClearList() 
{
	m_playlist.ClearList(); // clear the list
	
	// clear the information strings
	m_currentSong = "";
	m_title = "";
	m_index = "";
	m_number = "";

	UpdateData(FALSE);
	
}

// This method is called when the user clicks the Previous button
void CPlayListGeneratorDlg::OnPrevious() 
{
	m_playlist.SelectPreviousSong(); // call the select previous song method	
}

// This method is called when the user clicks the Next button
void CPlayListGeneratorDlg::OnNext() 
{
	m_playlist.SelectNextSong(); // call the select next song method	
}

// This method is called when the user clicks the Random button
void CPlayListGeneratorDlg::OnRandom() 
{
	m_playlist.SelectRandomSong(); // call the select random song method
}

// This method is called when the user clicks the Save List button
void CPlayListGeneratorDlg::OnSave() 
{
	m_playlist.Save(""); // call the save method with an empty string so it will present a dialog
}

// This method is called when the user clicks the Load List button
void CPlayListGeneratorDlg::OnLoad() 
{
	m_playlist.Load(""); // call the load method with an empty string so it will present a dialog
}

// This method is called when the user clicks the Background Color button
void CPlayListGeneratorDlg::OnBkColor() 
{
	// create and display the color dialog to the user
	CColorDialog dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		COLORREF color = dlg.GetColor(); // get the chosen color
		
		// call the SetBkColor method with the selected values
		m_playlist.SetBkColor(GetRValue(color), GetGValue(color), GetBValue(color));     
	}
}

// This method is called when the user clicks the Text Color button
void CPlayListGeneratorDlg::OnTextColor() 
{
	// create and display the color dialog to the user
	CColorDialog dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		COLORREF color = dlg.GetColor(); // get the chosen color
		
		// call the SetTextColor method with the selected values
		m_playlist.SetTextColor(GetRValue(color), GetGValue(color), GetBValue(color));     
	}	
}

// This method is called when the user clicks the Text Background Color button
void CPlayListGeneratorDlg::OnTextBkColor() 
{
	// create and display the color dialog to the user
	CColorDialog dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		COLORREF color = dlg.GetColor(); // get the chosen color
		
		// call the SetTextBkColor method with the selected values
		m_playlist.SetTextBkColor(GetRValue(color), GetGValue(color), GetBValue(color));     
	}	
}

void CPlayListGeneratorDlg::OnMvsbutton() 
{
    // Executes an open command to the Moon Valley website.  The system's default
    // viewer for webpages will be initialized to view the page.
    ShellExecute(NULL, "open", "http://www.moonvalley.com/", "", NULL, SW_SHOWNORMAL);
}
